#include <C:\cc5x\12F675.h>
#pragma config |= 0b.1101.0011.0000

//I2C-Interface
#pragma bit sda @ GPIO.0 //Datenleitung SDA (Pin 2)
#pragma bit scl @ GPIO.1 //Taktleitung SCL  (Pin 1)
#pragma bit tsda @ TRISIO.0 //Richtung von SDA
#pragma bit tscl @ TRISIO.1 //Richtung von SCL
#pragma bit Frost @ GPIO.2 //Pin 9
#pragma bit ChSel @ GPIO.4 //Pin 3

#include "I2C.c" //I2C-Emulator includen
#include "common.c"
#include "DSM-0822A.c"

const char TempDec[16] = { //Lookup-Tabelle fr die Dezimalstellen des Thermometers 
	00, 06, 13, 19, 25, 31, 38, 44, //(errechnen wre auch mglich, bruchte aber in etwa gleich viel Speicher)
  50, 56, 63, 69, 75, 81, 88, 94
	};

void main()
{
	
	//bisschen was einstellen:
	OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4
	CMCON=0x07; //alles digitale IO-Pins
	ANSEL=0x00; //alles digitale IO-Pins

	
	char tempa, tempb, decten, decone, DS75Addr;
	bit tempsgn, lstChSel;
	TRISIO=0b.0011.1011;
	WPU=0b.0011.0011;
	LCD_Init(); //LCD initialisieren und lschen
	
	DS75Addr = 0;
	
	while(1) {
		readtemp:
		
		while(ChSel == 0) {
			if (lstChSel == 1) DS75Addr++;
			if (DS75Addr == 8) DS75Addr = 0;

			LCDString(0, "SENSOR ");
			Ausgabe(7, DS75Addr+49);
			wait(50);
			lstChSel = ChSel;
		}
		
		
		//Auflsung des DS75 auf 12 Bit erhhen (0. Device)
		bstart();
		if (schreib(144+DS75Addr*2) == 1) { //Device zum Schreiben selektieren
			bstop(); //Kommunikation anhalten, damit die anderen Devices nicht stehen...
			Frost = 1;
			LCDString(0, "---,--#C");
			wait(100);
			Frost = 0;
			wait(100);
			goto readtemp;
		}
		
		schreib(1); //Pointer auf Configure setzen
		schreib(96); //Auflsung setzen, 12bit
		bstop();
		
		bstart();
		schreib(144+DS75Addr*2); //Device zum Schreiben selektieren
		schreib(0); //Pointer auf Temperatur setzen
		bstop();
		
		//Die Temperatur des DS75 auslesen
		bstart(); //Start
		schreib(145+DS75Addr*2); //Bauteiladresse senden zum Lesen
		tempa=lesen(); //Byte einlesen, Temperatur in Grad
		bitaus(0); //ACK
		tempb=lesen(); //Byte einlesen
		bitaus(1); //NO ACK
		bstop(); //Stopp
		
		tempsgn = 0; //Vorzeichen zurcksetzen
		
		if (tempa > 127) { //Wenn der ausgelesene Wert grer als 127 ist, ist die Temperatur negativ
			tempa = 256 - tempa; //Deshalb muss der "richtige" Wert berechnet werden
												 //Es ist zwar auch Temp-256 mglich, wrde aber nichts bringen, da char keine negativen Zahlenwerte untersttzt.
			tempsgn = 1; //Das Vorzeichen noch umschalten
			Frost = 1; //Den Frostwarner aktivieren
		} else {
			Frost = 0; //Wenn die Temperatur positiv ist, wird der Frostwarner deaktivert
		}
    if (tempa < 4) { //Zustzlich wird der Frostwarner aktiviert, wenn sich die Temperatur unter 4C befindet
			Frost = 1;
		}
		
		LCDString(3,","); //Das Komma ausgeben

		tempb=tempb>>4; //Die Bits der Dezimalstellen um vier Stellen nach rechts verschieben
		if (tempsgn == 1) { //Wenn die Temperatur negativ ist, muss 
			tempa--;
			tempb=16-tempb;  //Die Tabelle invertieren
		}
		
		tempb = TempDec[tempb]; //k erst mal einem Wert der Tabelle zuordnen
		decten = tempb/10; //der Zehner der Tabelle ist k/10
		decone = tempb-decten*10; //der Einer ist k minus der Zehner
		Ausgabe(4, (char)decten+0x30); //0x30 addieren, damit die Zahl in den Zeichensatz passt
		Ausgabe(5, (char)decone+0x30); //s. o.
		LCDString(6, "#C"); //C ausgeben
		
		ZalString(0, tempa); //Die Temperatur an das Display ausgeben
		
		if (tempsgn == 1) { //Wenn die Temperatur negativ ist, muss vorne noch ein - ausgegeben werden
			LCDString(0, "-");
		}
		
		wait(250); //250ms warten
		wait(250); //250ms warten

	}
}